HDU 1969 Pie(二分,注意精度)

Pie

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 16554    Accepted Submission(s): 5829
 
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though. 

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different. 

InputOne line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends. 
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies. 
OutputFor each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327
3.1416
50.2655

题意:N种蛋糕,每个半径给出,要分给F+1个人,要求每个人分的体积一样(形状可以不一样),而且每人只能分得一种蛋糕(不能多种蛋糕拼在一起),求每人最大可以分到的体积。

 

思路:初始下界为0,上界为最大的蛋糕体积,二分求出结果。

#include <stdio.h>
#include <iostream>
#include <string.h>
#include <algorithm>
#include <math.h>
#include<cmath>
using namespace std ;
#define MAX 10005
double S[MAX] ;
double N , F ;
int main()
{
    int T ;
    double PI=acos(double(-1));
    scanf("%d" , &T) ;
    while(T--)
    {
        //cin >> N >> F ;
        scanf("%lf%lf",&N,&F) ;
        F ++ ;
        double ri ;
        double ma = 0.0 ;
        for(int i = 0 ; i < N ; i ++)
        {
            //cin >> ri ;
            scanf("%lf" ,&ri) ;
            S[i] = PI*ri*ri ;
            if(S[i] > ma) ma = S[i] ;
        }
        double l = 0 , r =ma ,mid ;
        int cnt ;
        while(r - l >= 0.0000001)
        {
            mid = (l + r) / 2 ;
            cnt = 0 ;
            for(int i = 0 ; i < N ; i ++)
            {
                cnt += int(S[i]/mid) ;
            }
            if(cnt >= F)
            {
                l = mid ;
            }
            else r = mid ;
        }
        printf("%.4f\n",l) ;
    }
}


猜你喜欢

转载自www.cnblogs.com/caiyishuai/p/9541807.html